# -*- coding: utf-8 -*-
from setuphelpers import *
import time


def install():

    print("uninstall tis-nmap")
    for soft in installed_softwares("nmap"):
        run(uninstall_cmd(soft["key"]))
        wait_uninstallkey_absent(soft["key"])
        time.sleep(15)

    print("installing tis-nmap")
    version = control["version"].split("-", 1)[0]
    install_exe_if_needed(
        "nmap-%s-setup.exe" % version,
        "/VERYSILENT /SUPPRESSMSGBOXES /NORESTART /S",
        key="",
        min_version=version,
    )

    # Kill at end of installation
    killalltasks("nmap.exe")


def uninstall():
    print("uninstall tis-nmap")
    for soft in installed_softwares("nmap"):
        run(uninstall_cmd(soft["key"]))
        wait_uninstallkey_absent(soft["key"])
        time.sleep(15)
    # def update_package():
    #     # Do not update this package, the lastest silent installable nmap 7.01
    #     pass
    """import bs4 as BeautifulSoup,requests,re
    from waptpackage import PackageEntry
    import requests
    from requests.adapters import HTTPAdapter
    from requests.packages.urllib3.util.retry import Retry
    from urllib.request import urlopen


    proxies = {}
    if isfile(makepath(application_data(),'waptconsole','waptconsole.ini')):
        proxywapt = inifile_readstring(makepath(user_local_appdata(),'waptconsole','waptconsole.ini'),'global','http_proxy')
        if proxywapt :
            proxies = {'http':'http://srvproxy:8080','https':'http://srvproxy:8080'}

    print(proxies)

    verify=True
    pe = PackageEntry()
    pe.load_control_from_wapt(os.getcwd())
    current_version = pe['version'].split('-',1)[0]
    verify=True

    urlversion = 'https://nmap.org/download.html'

    
    page = requests.get(urlversion,headers={'User-Agent':'Mozilla/5.0 (Windows NT 6.1; Win64; x64)'},verify=verify,proxies=proxies).text
    bs = BeautifulSoup.BeautifulSoup(page,features='html.parser')

    bs_raw_string = str(bs.findAll('b')[2]).split('nmap-',1)[1]
    version = bs_raw_string.split('-',1)[0]


    print(version)


    url = 'https://nmap.org/dist/'
    url64 = url + "nmap-%s-setup.exe" % version
    print(url64)



    filenamex64 = "nmap-%s-setup.exe" % version


    for fileexe in glob.glob('*.exe'):
        if fileexe != filenamex64 :
            print('Delete ' + fileexe)
            remove_file(fileexe)

    if not isfile(filenamex64):
        print('Download ' + url64)
        wget(url64,filenamex64,proxies=proxies)

    from waptpackage import PackageEntry
    pe = PackageEntry()
    pe.load_control_from_wapt(os.getcwd())

    pe.version = version + '-0'
    pe.save_control_to_wapt(os.getcwd())"""
